import React from 'react';
import { ThemeContext } from './theme-context';

function ThemeTogglerButton() {
    // Theme Toggler 按钮不仅接收 theme 属性
    // 也接收了一个来自 context 的 toggleTheme 函数
    return (
        <ThemeContext.Consumer >
            {
                ({ theme, toggleTheme }) =>(
                    <button onClick = { toggleTheme }
                        style={{
                            color: theme.foreground,
                            backgroundColor: theme.background
                        }}
                    >
                        Toggle Theme 
                    </button>
                )
            } 
        </ThemeContext.Consumer>
    );
}

export default ThemeTogglerButton;